<template>
  <ob-form
    :form-data="formData"
    :form-model="formModel"
    :is-read-only="!isNew"
    @submit="onSubmitHandler"
    :dropdown-menu="dropdownMenu"
  >
    <div class="row">
      <div class="col-xs-6">
        <ob-input
          :label="dictionaryRu.modal.denomination"
          v-model="formData.denomination"
          :placeholder="dictionaryRu.modal.denomination_placeholder"
          :disabled="!isNew"
        />
      </div>
      <div class="col-xs-6">
        <ob-selector
          :label="dictionaryRu.modal.tracker_denomination"
          :placeholder="dictionaryRu.modal.tracker_denomination_placeholder"
          v-model="formData.tracker.uuid"
          :items="trackingMethods"
          value-exp="uuid"
          display-exp="denomination"
          :disabled="!isNew"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-textarea
          :label="dictionaryRu.modal.description"
          :placeholder="dictionaryRu.modal.description_placeholder"
          v-model="formData.description"
          :disabled="!isNew"
        />
      </div>
    </div>
  </ob-form>
</template>

<script>
import FormValidationMixin from "common-components/src/obComponents/obForm/FormValidationMixin";
import models from "@/models";
import cloneDeep from "clone-deep";
import ObForm from "common-components/src/obComponents/obForm";
import ObInput from "common-components/src/obComponents/obInput";
import ObSelector from "common-components/src/obComponents/obSelect";
import ObTextarea from "common-components/src/obComponents/obTextarea";
import dropdownEvents from "@/mixins/dictionaries/dropdown-events";
import { dictionary } from '@/translations/ru/dictionaries__temperature__temperature_recorders';

export default {
  name: "TemperatureRecorder",
  components: { ObForm, ObInput, ObSelector, ObTextarea },
  mixins: [FormValidationMixin, dropdownEvents],
  props: {
    dataSource: {
      type: Object,
      default: () => {}
    },
    trackingMethods: {
      type: Array,
      default: () => []
    }
  },
  data () {
    return {
      dictionaryRu: dictionary
    }
  },
  computed: {
    formModel() {
      return models.temperatureRecorder.add;
    },
    isNew() {
      return !this.formData.uuid;
    }
  },
  methods: {
    onSubmitHandler() {
      const data = cloneDeep(this.formData);

      if (data.tracker.uuid) {
        data.tracker_uuid = data.tracker.uuid || {};
      }

      this.$emit("submit", { formData: data, model: this.formModel });
    }
  }
};
</script>

